package org.nl.acs.device.service;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import org.nl.acs.device.domain.Device;
import org.nl.acs.storage_cell.service.dto.StorageCellDto;
import org.nl.acs.common.base.PageInfo;
import org.nl.acs.common.base.CommonService;
import org.nl.acs.device.service.dto.DeviceDto;
import org.nl.acs.device.service.dto.DeviceQueryParam;
import org.springframework.data.domain.Pageable;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
* @author jiaolm
* @date 2023-05-09
*/
public interface DeviceService extends CommonService<Device>  {

    static final String CACHE_KEY = "device";

    /**
    * 查询数据分页
    * @param query 条件
    * @param pageable 分页参数
    * @return PageInfo<DeviceDto>
    */
    PageInfo<DeviceDto> queryAll(DeviceQueryParam query, Pageable pageable);

    /**
    * 查询所有数据不分页
    * @param query 条件参数
    * @return List<DeviceDto>
    */
    List<DeviceDto> queryAll(DeviceQueryParam query);

    Device getById(String id);
    DeviceDto findById(String id);

    /**
     * 插入一条新数据。
     */
    int insert(DeviceDto resources);
    int updateById(DeviceDto resources);
    int removeById(String id);
    int removeByIds(Set<String> ids);

    /**
    * 导出数据
    * @param all 待导出的数据
    * @param response /
    * @throws IOException /
    */
    // void download(List<DeviceDto> all, HttpServletResponse response) throws IOException;
    /**
     * 查询数据分页
     *
     * @param whereJson 条件
     * @param page      分页参数
     * @return Map<String, Object>
     */
    Map<String, Object> queryAll(Map whereJson, Pageable page);

    /**
     * 查询设备协议
     *
     * @param whereJson 条件
     * @param page      分页参数
     * @return Map<String, Object>
     */
    Map<String, Object> queryDeviceProtocol(Map whereJson, Pageable page);

    /**
     * 查询设备协议
     *
     * @param whereJson 条件
     * @return Map<String, Object>
     */
    JSONArray queryDeviceProtocol(Map whereJson);

    /**
     * 查询所有数据不分页
     *
     * @param whereJson 条件参数
     * @return List<DeviceDto>
     */
    List<DeviceDto> queryAll(Map whereJson);

    /**
     * 根据ID查询
     *
     * @param device_id ID
     * @return Device
     */
//    DeviceDto findById(String device_id);

    /**
     * 根据编码查询
     *
     * @param code code
     * @return Device
     */
    DeviceDto findByCode(String code);

    /**
     * 创建
     *
     * @param dto /
     */
    void create(DeviceDto dto);

    /**
     * 编辑
     *
     * @param dto /
     */
    void update(DeviceDto dto);

    /**
     * 多选删除
     *
     * @param ids /
     */
    void deleteAll(String[] ids);

    /**
     * 导出数据
     *
     * @param dtos     待导出的数据
     * @param response /
     * @throws IOException /
     */
    void download(List<DeviceDto> dtos, HttpServletResponse response) throws IOException;

    /**
     * 导出设备db协议
     *
     * @param jsonarr
     * @param response
     * @throws IOException
     */
    void downDeviceDBload(JSONArray jsonarr, HttpServletResponse response) throws IOException;

    /**
     * 前端设备下拉选列表
     *
     * @return
     */
    JSONArray selectList();

    /**
     * 前端输送设备下拉选列表
     *
     * @return
     */
    JSONArray selectConveyorList();

    /**
     * 根据区域查询设备
     *
     * @return
     */
    JSONArray selectDeviceListByRegion(String region);

    /**
     * 查询设备驱动信息
     *
     * @param status 所属区域
     * @param status 状态
     * @return
     */
    JSONArray selectDeviceDevicerInfo(String status);

    /**
     * 查询区域一设备
     *
     * @return
     */
    JSONArray selectDeviceListOne();

    /**
     * 查询区域二设备
     *
     * @return
     */
    JSONArray selectDeviceListTwo();

    /**
     * 查询区域三设备
     *
     * @return
     */
    JSONArray selectDeviceListThree();

    /**
     * 更新驱动配置信息
     *
     * @param form parentForm：设备主表信息，form：设备驱动子表单扩展信息  data1：DB读列表，data2:DB写列表
     */
    void updateConfig(JSONObject form);

    /**
     * 通过设备监控图改变设备状态
     *
     * @param form
     */
    void changeDeviceStatus(JSONObject form);

    /**
     * 改变电子围栏状态
     *
     * @param form
     */
    void changeFenceStatus(JSONObject form);

    /**
     * 呼叫请求
     *
     * @param form
     */
    void callAgv(JSONObject form);

    /**
     * 添加物料信息
     *
     * @param form
     */
    void addMaterial(JSONObject form);

    /**
     * 响应请求参数
     *
     * @param form
     */
    void responseAgv(JSONObject form);

    void autoCreateTask(JSONObject json);

    /**
     * 解除设备锁标记
     *
     * @param deviceCodes
     */
    void unlock(List<String> deviceCodes);

    void cleanTask(JSONObject json);

    void cleanMaterial(JSONObject json);

    /**
     * 根据设备标识查询设备驱动配置,如果未配置过，就从驱动配置定义找，否则从数据库里面找
     *
     * @param device_id
     */
    JSONObject queryDriverConfigByDeviceId(String device_id, String driver_code);

    /**
     * DB测试读
     *
     * @return
     */
    JSONArray testRead(Map map);

    /**
     * DB测试写
     *
     * @return
     */
    void testWrite(Map map);

    void downDeviceDBloadCSV(JSONArray queryDeviceProtocol, HttpServletResponse response);

    void downDeviceDBloadOumulongCSV(JSONArray queryDeviceProtocol, HttpServletResponse response);

    JSONArray selectDeviceListByType(String type);

    /**
     * 根据货架号，查询扩展信息
     */
    JSONObject queryStorageExtra(String device_code);

    String queryScannerByCode(String code) throws Exception;

    void reload();

    List<StorageCellDto> queryAllStorageCell();

    /**
     * 缓存中查询所有货位
     *
     * @return
     */
    List<StorageCellDto> findAllStorageCellFromCache();

    int queryAddressBydeviceCode(String code);

    String queryDeviceCodeByAddress(int address);

    List<Device> findCacheDevice();

    void updateBarcode(JSONObject json) throws Exception;

    /**
     * 根据驱动编码获取db信息
     *
     * @param driver_code
     */
    JSONObject queryDBInfoByDriverCode(String driver_code);

    /**
     * 导出数据
     *
     * @param whereJson     待导出的数据
     * @param response /
     * @throws IOException /
     */
    void downloadProtocolConfig(JSONObject whereJson, HttpServletResponse response) throws IOException;

    void downDeviceDBloadSmartCSV(JSONArray queryDeviceProtocol, HttpServletResponse response);

    void downDeviceDBloadFX5UCSV(JSONArray queryDeviceProtocol, HttpServletResponse response);

    /**
     * excel导入
     * @param file
     * @param request
     */
    void excelImport(MultipartFile file, HttpServletRequest request);
}
